﻿using System.Collections.Generic;

namespace TouchTokens
{
	/*
	 *   Authors: Caroline Appert (caroline.appert@lri.fr)
	 *   Copyright (c) Univ. Paris-Sud XI, 2015. All Rights Reserved
	 *   Licensed under the GNU LGPL. For full terms see the file COPYING.
	*/

	public class MultiTouchInput
	{

		protected List<TouchPoint> points;

		public MultiTouchInput(List<TouchPoint> points) : base()
		{
			this.points = points;
		}

		public virtual List<TouchPoint> Points
		{
			get
			{
				return points;
			}
            set
            {
                this.points = value;
            }
		}

		public override string ToString()
		{
			string points = "[";
			foreach (TouchPoint pt in this.points)
			{
				points += "(" + (int)pt.X + "," + (int)pt.Y + ")";
			}
			points += "]";
			return points;
		}

	}

}