﻿using System;

namespace TouchTokens
{
	/*
	 *   Authors: Caroline Appert (caroline.appert@lri.fr)
	 *   Copyright (c) Univ. Paris-Sud XI, 2015. All Rights Reserved
	 *   Licensed under the GNU LGPL. For full terms see the file COPYING.
	*/

	public class TouchPoint
	{

		public double x;
		public double y;

		public TouchPoint()
		{
		}

		public TouchPoint(double x, double y)
		{
			this.x = x;
			this.y = y;
		}

		public virtual double X
		{
			get
			{
				return x;
			}
			set
			{
				this.x = value;
			}
		}
		public virtual double Y
		{
			get
			{
				return y;
			}
			set
			{
				this.y = value;
			}
		}

		public override string ToString()
		{
			return "[" + x + ", " + y + "]";
		}

		public virtual double distance(TouchPoint p)
		{
			return Math.Sqrt((p.x - x) * (p.x - x) + (p.y - y) * (p.y - y));
		}

		public virtual double distanceX(TouchPoint p)
		{
			return p.x - x;
		}

		public virtual double distanceY(TouchPoint p)
		{
			return p.y - y;
		}

		public virtual void setLocation(double x, double y)
		{
			this.x = x;
			this.y = y;
		}

	}

}