using System;
using TUIO;

namespace WTT
{
	public interface TuioWallTokenListener : TuioListener
    {
    	/**
         * <summary>
         * This callback method is invoked by the TuioClient when a new TuioWallToken is added to the session.</summary>
         *
         * <param name="tok">the TuioWallToken reference associated to the addTuioWallToken event</param>
         */
        void addTuioWallToken(TuioWallToken tok);

        /**
         * <summary>
         * This callback method is invoked by the TuioClient when an existing TuioWallToken is updated during the session.</summary>
         *
         * <param name="tok">the TuioWallToken reference associated to the updateTuioWallToken event</param>
         */
        void updateTuioWallToken(TuioWallToken tok);

        /**
         * <summary>
         * This callback method is invoked by the TuioClient when an existing TuioWallToken is removed from the session.</summary>
         *
         * <param name="tok">the TuioWallToken reference associated to the removeTuioWallToken event</param>
         */
        void removeTuioWallToken(TuioWallToken tok);

    }
}