using System;
using System.Threading;

namespace WTT
{
	class WallTokensTuioFwder
	{

		private static bool run = true;

		// recieving from TUIO
		private static int inPort = 3333;

		// sending to a TUIO Client ()
		private static int outPort = 13333;
		private static string outIP = "127.0.0.1";

		private static int mode = 1; 
		// token
		private static string templateFileName = "Resources/templates/template.txt";

		private  static float screenWidthMM = 1000;
		private  static float screenHeightMM = 500;

		private static int verbosity = 1;

		private static void printHelp(){
			Console.WriteLine("Usage:");
			Console.WriteLine("\n\tmono wall-token-tuio.exe [options]\n");
			Console.WriteLine("Options:");
			Console.WriteLine("\t-ip port \t input port [default 3333]");
			Console.WriteLine("\t-op port \t output port [default 13333]");
			Console.WriteLine("\t-oip ip \t output IP [default 127.0.0.1]");
			Console.WriteLine("\t-m mode \t mode=1,2 or 3. 1: WallToken as TuioObject (default), 2: WallToken as TuioCursor, 3: Extended TUIO");
			Console.WriteLine("\t-tf path \t path to the template file [Resources/templates/template.txt]");
			Console.WriteLine("\t-sw w \t\t width in mm of the input surface [default 1000]");
			Console.WriteLine("\t-sh h \t\t height in mm of the input surface [default 500]");
			Console.WriteLine("\t-v value \t verbosity, 0: nothing; 1: start info (default), 2: 1 + add/remove, 3: 2 + update ");
			Console.WriteLine("\t-h \t\t print this help and exit\n");

		} 
		public static void Main(string[] args)
		{
			// Console.WriteLine("starting ....");
			//outPort = 0;
     		for (int i = 0; i < args.Length; i++) {
         		//Console.WriteLine("ARG " + i + ": " + args [i]);
         		if (args [i] == "-op") {
         			outPort = int.Parse(args [i + 1]);
         			i++;
         		}
         		else if (args[i] == "-oip") {
         			outIP = args[i + 1];
         			i++;
         		}
         		if (args [i] == "-ip") {
         			inPort = int.Parse(args [i + 1]);
         			i++;
         		}
         		else if (args[i] == "-tf") {
         			templateFileName = args[i + 1];
         			i++;
         		}
         		else if (args[i] == "-sw") {
         			screenWidthMM = float.Parse(args[i + 1]);
         			i++;
         		}
         		else if (args[i] == "-sh") {
         			screenHeightMM = float.Parse(args[i + 1]);
         			i++;
         		}
         		else if (args[i] == "-m") {
         			mode = int.Parse(args[i + 1]);
         			i++;
         		}
         		else if (args[i] == "-v") {
         			verbosity = int.Parse(args[i + 1]);
         			i++;
         		}
         		else if (args[i] == "-h" || args[i] == "--h" || args[i] == "--help" || args[i] == "-help"){
         			printHelp();
         			return;
         		}
         	}
			

			WallTokensTuio wtt = new WallTokensTuio(inPort, templateFileName, screenWidthMM, screenHeightMM, outPort, outIP,  mode);
			wtt.SetVerbosity(verbosity);
			wtt.Start();
  			
			while(run){
				Thread.Sleep(1);
			}
		}

	}

}